	; FC Sound Sequencer

;FSSQ_CART_TYPE_MMC3	.equ	1
FSSQ_CART_TYPE_MCAFE_E1	.equ	4064

FSSQ_BGM_TRACK_SIZE	.equ	4
FSSQ_SE_TRACK_SIZE	.equ	2
FSSQ_TRACK_SIZE		.equ	(FSSQ_BGM_TRACK_SIZE+FSSQ_SE_TRACK_SIZE)

; 0:full 1:half-size
FSSQ_KEY_TABLE_SIZE	.equ	0

FSSQ_FREQ_H	.func	((\1)>>7)
FSSQ_FREQ_L	.func	(((\1)&($7f))|($80))

; _FSSQ_CCTRL  untx---s
; u: XV̂(SEɊ肱܂ĂBGMCH)
; n: mCYCH
; t: OpgCH
; x: gCH
; s: SE

_FSSQ_SEQ	.equ	FNC_WORK    ; 2bytes
_FSSQ_LENTBL	.equ	FNC_WORK+2  ; 2bytes
_FSSQ_ENVTBL	.equ	FNC_WORK+4  ; 2bytes
_FSSQ_TR_INX	.equ	FNC_WORK+6
_FSSQ_CH_INX	.equ	FNC_WORK+7
_FSSQ_CH_BIT	.equ	FNC_WORK+8
_FSSQ_CCTRL	.equ	FNC_WORK+9
_FSSQ_PREG	.equ	FNC_WORK+10
_FSSQ_TICK	.equ	FNC_WORK+11
_FSSQ_WORK1	.equ	FNC_ARG     ; 2bytes
_FSSQ_WORK2	.equ	FNC_ARG+2   ; 2bytes

; FSSQ_STAT    ---bbbb
; FSSQ_STAT+1  ---eeee
; FSSQ_STAT+2  ---nnnn
; b: BGMgpĂCHBitmap
; e: SE gpĂCHBitmap
; n: CHBitmap(x≹ʃ[CHbitȂ)

; FSSQ_BCTRL  eebb----
; b: BGM̃oN(00:Ȃ 01:$a000ύX 10:$b000ύX)
; e: SE ̃oN(00:Ȃ 01:$a000ύX 10:$b000ύX)

FSSQ_STAT	.equ	$d0 ;   3 bytes
FSSQ_BCTRL	.equ	$d3
FSSQ_REF	.equ	$d4 ;   2 bytes
; FSSQ_EXT_REF	.equ	$d6 ;   2 bytes
FSSQ_KEY_L	.equ	$d8 ;   6 bytes (TR)
FSSQ_KEY_H	.equ	$de ;   6 bytes (TR)
FSSQ_EINX	.equ	$e4 ;   6 bytes (TR)
FSSQ_NCNT	.equ	$ea ;   6 bytes (TR)

; InitŃ[(from)
FSSQ_PCMCALL	.equ	$0300 ;   2 bytes
FSSQ_PCMNUM	.equ	$0302
FSSQ_FADEOUT	.equ	$0303
FSSQ_PAUSE	.equ	$0304
FSSQ_LOOP_CNT	.equ	$0305
FSSQ_TCNT	.equ	$0306 ;   2 bytes
FSSQ_TEMPO	.equ	$0308 ;   2 bytes
FSSQ_BANK	.equ	$030a ;   2 bytes
FSSQ_LENTBL_L	.equ	$030c ;   2 bytes
FSSQ_LENTBL_H	.equ	$030e ;   2 bytes
FSSQ_ENVTBL_L	.equ	$0310 ;   2 bytes
FSSQ_ENVTBL_H	.equ	$0312 ;   2 bytes
FSSQ_SEQ_L	.equ	$0314 ;   6 bytes (TR)
FSSQ_SEQ_H	.equ	$031a ;   6 bytes (TR)
; InitŃ[(to)
FSSQ_CH		.equ	$0320 ;   6 bytes (TR)
FSSQ_KEYON	.equ	$0326 ;   6 bytes (TR)
FSSQ_LCNT	.equ	$032c ;   6 bytes (TR)
FSSQ_REG1	.equ	$0332 ;   6 bytes (TR)
FSSQ_REG2	.equ	$0338 ;   6 bytes (TR) L惊s[g̃[vJE^ƌp
FSSQ_TBASE	.equ	$033e ;   6 bytes (TR)
FSSQ_LBASE	.equ	$0344 ;   6 bytes (TR)
FSSQ_EBASE	.equ	$034a ;   6 bytes (TR)
FSSQ_VCNT	.equ	$0350 ;   6 bytes (TR)
FSSQ_VACC	.equ	$0356 ;   6 bytes (TR)
FSSQ_S_SEQ_L	.equ	$035c ;   4 bytes (BGM TR)
FSSQ_S_SEQ_H	.equ	$0360 ;   4 bytes (BGM TR)
FSSQ_S_TBASE	.equ	$0364 ;   4 bytes (BGM TR)
FSSQ_S_LBASE	.equ	$0368 ;   4 bytes (BGM TR)
FSSQ_TR		.equ	$036c ;   4 bytes (CH)
FSSQ_TREG	.equ	$0370 ; 4*4 bytes (CH)

Fssq_DataTable:
.align1:
	.org	(HIGH(.align1-1)+1)*256
Fssq_SustainRate:
	.db	$00, $01, $02, $03, $04, $05, $06, $07
	.db	$08, $09, $0a, $0c, $0e, $10, $12, $14
Fssq_ReleaseRate:
	.db	$ff, $80, $55, $40, $2a, $20, $17, $12
	.db	$10, $0d, $0a, $08, $06, $04, $02, $01
Fssq_MulTable:
	.db	$00,$10,$20,$30,$51,$61,$71,$81,$91,$a1,$b1,$c1,$e2,$f2,$f2,$f2
	.db	$00,$10,$31,$41,$51,$61,$82,$92,$a2,$b2,$d3,$e3,$f3,$f3,$f4,$f4
	.db	$00,$10,$31,$41,$62,$72,$82,$a3,$b3,$c3,$e4,$f4,$f5,$f5,$f5,$f6
	.db	$00,$21,$31,$52,$62,$83,$93,$b4,$c4,$e5,$f5,$f6,$f6,$f7,$f7,$f8
	.db	$00,$21,$31,$52,$73,$83,$a4,$b4,$d5,$f6,$f6,$f7,$f8,$f8,$f9,$f9
	.db	$00,$21,$42,$52,$73,$94,$b5,$c5,$e6,$f7,$f8,$f8,$f9,$fa,$fb,$fb
	.db	$00,$21,$42,$63,$84,$94,$b5,$d6,$f7,$f8,$f9,$fa,$fb,$fb,$fc,$fd
	.db	$00,$21,$42,$63,$84,$a5,$c6,$e7,$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff

Fssq_ToReflect:
	.db	 0,  4,  8, 12,  1,  5,  9, 13
	.db	 2,  6, 10, 14,  3,  7, 11, 15

Fssq_ToCtrl:
	.db	$00, $00, $20, $40

Fssq_NextCh:
	.db	FSSQ_BGM_TRACK_SIZE
	.db	FSSQ_BGM_TRACK_SIZE+FSSQ_SE_TRACK_SIZE

	.if	FSSQ_KEY_TABLE_SIZE = 0
Fssq_Apu_KeyTable_L:
	; o2
	.db	LOW(1710), LOW(1614), LOW(1524), LOW(1438)
	.db	LOW(1357), LOW(1281), LOW(1209), LOW(1141)
	.db	LOW(1077), LOW(1017), LOW( 960), LOW( 906)

	; o3
	.db	LOW( 855), LOW( 807), LOW( 762), LOW( 719)
	.db	LOW( 679), LOW( 640), LOW( 604), LOW( 571)
	.db	LOW( 539), LOW( 508), LOW( 480), LOW( 453)

	; o4
	.db	LOW( 427), LOW( 403), LOW( 381), LOW( 359)
	.db	LOW( 339), LOW( 320), LOW( 302), LOW( 285)
	.db	LOW( 269), LOW( 254), LOW( 240), LOW( 226)

	; o5
	.db	LOW( 214), LOW( 202), LOW( 190), LOW( 180)
	.db	LOW( 170), LOW( 160), LOW( 151), LOW( 143)
	.db	LOW( 135), LOW( 127), LOW( 120), LOW( 113)

	; o6
	.db	LOW( 107), LOW( 101), LOW(  95), LOW(  90)
	.db	LOW(  85), LOW(  80), LOW(  75), LOW(  71)
	.db	LOW(  67), LOW(  63), LOW(  60), LOW(  56)

	; o7
	.db	LOW(  53), LOW(  50), LOW(  47), LOW(  45)
	.db	LOW(  42), LOW(  40), LOW(  38), LOW(  36)
	.db	LOW(  34), LOW(  32), LOW(  30), LOW(  28)

Fssq_Apu_KeyTable_H:
	; o2
	.db	HIGH(1710), HIGH(1614), HIGH(1524), HIGH(1438)
	.db	HIGH(1357), HIGH(1281), HIGH(1209), HIGH(1141)
	.db	HIGH(1077), HIGH(1017), HIGH( 960), HIGH( 906)

	; o3
	.db	HIGH( 855), HIGH( 807), HIGH( 762), HIGH( 719)
	.db	HIGH( 679), HIGH( 640), HIGH( 604), HIGH( 571)
	.db	HIGH( 539), HIGH( 508), HIGH( 480), HIGH( 453)

	; o4
	.db	HIGH( 427), HIGH( 403), HIGH( 381), HIGH( 359)
	.db	HIGH( 339), HIGH( 320), HIGH( 302), HIGH( 285)
	.db	HIGH( 269), HIGH( 254), HIGH( 240), HIGH( 226)

	; o5
	.db	HIGH( 214), HIGH( 202), HIGH( 190), HIGH( 180)
	.db	HIGH( 170), HIGH( 160), HIGH( 151), HIGH( 143)
	.db	HIGH( 135), HIGH( 127), HIGH( 120), HIGH( 113)

	; o6
	.db	HIGH( 107), HIGH( 101), HIGH(  95), HIGH(  90)
	.db	HIGH(  85), HIGH(  80), HIGH(  75), HIGH(  71)
	.db	HIGH(  67), HIGH(  63), HIGH(  60), HIGH(  56)

	; o7
	.db	HIGH(  53), HIGH(  50), HIGH(  47), HIGH(  45)
	.db	HIGH(  42), HIGH(  40), HIGH(  38), HIGH(  36)
	.db	HIGH(  34), HIGH(  32), HIGH(  30), HIGH(  28)
	.endif
	.if	FSSQ_KEY_TABLE_SIZE = 1
Fssq_Apu_KeyTable:
	; o2,o3
	.db	FSSQ_FREQ_L(1710), FSSQ_FREQ_L(1614), FSSQ_FREQ_L(1524)
	.db	FSSQ_FREQ_L(1438), FSSQ_FREQ_L(1357), FSSQ_FREQ_L(1281)
	.db	FSSQ_FREQ_L(1209), FSSQ_FREQ_L(1141), FSSQ_FREQ_L(1077)
	.db	FSSQ_FREQ_L(1017), FSSQ_FREQ_L( 960), FSSQ_FREQ_L( 906)

	.db	FSSQ_FREQ_H(1710), FSSQ_FREQ_H(1614), FSSQ_FREQ_H(1524)
	.db	FSSQ_FREQ_H(1438), FSSQ_FREQ_H(1357), FSSQ_FREQ_H(1281)
	.db	FSSQ_FREQ_H(1209), FSSQ_FREQ_H(1141), FSSQ_FREQ_H(1077)
	.db	FSSQ_FREQ_H(1017), FSSQ_FREQ_H( 960), FSSQ_FREQ_H( 906)
	; o4,o5
	.db	FSSQ_FREQ_L( 427), FSSQ_FREQ_L( 403), FSSQ_FREQ_L( 381)
	.db	FSSQ_FREQ_L( 359), FSSQ_FREQ_L( 339), FSSQ_FREQ_L( 320)
	.db	FSSQ_FREQ_L( 302), FSSQ_FREQ_L( 285), FSSQ_FREQ_L( 269)
	.db	FSSQ_FREQ_L( 254), FSSQ_FREQ_L( 240), FSSQ_FREQ_L( 226)

	.db	FSSQ_FREQ_H( 427), FSSQ_FREQ_H( 403), FSSQ_FREQ_H( 381)
	.db	FSSQ_FREQ_H( 359), FSSQ_FREQ_H( 339), FSSQ_FREQ_H( 320)
	.db	FSSQ_FREQ_H( 302), FSSQ_FREQ_H( 285), FSSQ_FREQ_H( 269)
	.db	FSSQ_FREQ_H( 254), FSSQ_FREQ_H( 240), FSSQ_FREQ_H( 226)
	; o6,o7
	.db	FSSQ_FREQ_L( 107), FSSQ_FREQ_L( 101), FSSQ_FREQ_L(  95)
	.db	FSSQ_FREQ_L(  90), FSSQ_FREQ_L(  85), FSSQ_FREQ_L(  80)
	.db	FSSQ_FREQ_L(  75), FSSQ_FREQ_L(  71), FSSQ_FREQ_L(  67)
	.db	FSSQ_FREQ_L(  63), FSSQ_FREQ_L(  60), FSSQ_FREQ_L(  56)

	.db	FSSQ_FREQ_H( 107), FSSQ_FREQ_H( 101), FSSQ_FREQ_H(  95)
	.db	FSSQ_FREQ_H(  90), FSSQ_FREQ_H(  85), FSSQ_FREQ_H(  80)
	.db	FSSQ_FREQ_H(  75), FSSQ_FREQ_H(  71), FSSQ_FREQ_H(  67)
	.db	FSSQ_FREQ_H(  63), FSSQ_FREQ_H(  60), FSSQ_FREQ_H(  56)
	.endif

	; TEhhCo
	; use reg: a x
	; use work: none
Fssq_Init:
	lda	#$c0
	sta	$4017	; disable frame interrupt

	lda	#$00
	ldx	#$20-1
.1:
	sta	<$d0,x
	dex
	bpl	.1

;	lda	#$00
	ldx	#(FSSQ_CH-FSSQ_PCMCALL-1)
.2:
	sta	FSSQ_PCMCALL,x
	dex
	bpl	.2

;	ldx	#$ff
	stx	FSSQ_PCMNUM
	lda	#150
	sta	FSSQ_TEMPO
	sta	FSSQ_TEMPO+1

	rts

	; TEhhCo[DPCMĐR[obNݒ
	; a: CB[`̃AhX(LOW)
	; x: CB[`̃AhX(HIGH)
	; use reg: a x
	; use work: none
Fssq_SetDpcmCB:
	sta	FSSQ_PCMCALL
	stx	FSSQ_PCMCALL+1
	rts

	; TEhhCo[BGMoNݒ
	; a : bbnnnnnn (b:bank n:bank-num)
	; bb : 0:ύXȂ 1:$a000ύX 2:$b000ύX
	; use reg: a
	; use work: 0
Fssq_SetBankBGM:
	sta	<FNC_WORK
	and	#$3f
	sta	FSSQ_BANK
	eor	<FNC_WORK
	lsr	a
	lsr	a
	eor	<FSSQ_BCTRL
	and	#$30
	bcc	_Fssq_SetBank	; same as jmp

	; TEhhCo[SEoNݒ
	; a : bbnnnnnn (b:bank n:bank-num)
	; bb : 0:ύXȂ 1:$a000ύX 2:$b000ύX
	; use reg: a
	; use work: 0
Fssq_SetBankSE:
	sta	<FNC_WORK
	and	#$3f
	sta	FSSQ_BANK+1
	eor	<FNC_WORK
	eor	<FSSQ_BCTRL
	and	#$c0
_Fssq_SetBank:
	eor	<FSSQ_BCTRL
	sta	<FSSQ_BCTRL
	rts

	; TEhhCo[BGMt
	; a: p[^̃AhX(LOW)
	; x: p[^̃AhX(HIGH)
	; use reg: a x y
	; use work: 0-3
	; use arg: 0-7
Fssq_PlayBGM:
	jsr	Fssq_TransArgBGM
	sta	<FSSQ_STAT

	lda	#$00
	sta	FSSQ_TCNT
	sta	FSSQ_FADEOUT
	sta	FSSQ_LOOP_CNT
	ldx	#3
.1:
	sta	FSSQ_S_SEQ_H,x
	dex
	bpl	.1

	ldx	#3
	ldy	#3
	bne	_Fssq_Play	; same as jmp

	; TEhhCo[SEt
	; a: p[^̃AhX(LOW)
	; x: p[^̃AhX(HIGH)
	; use reg: a x y
	; use work: 0-3
	; use arg: 0-7
Fssq_PlaySE:
	jsr	Fssq_TransArgSE
	ldx	<FSSQ_STAT+1
	beq	.1
	sta	<FNC_WORK
	jsr	Fssq_StopSE
	lda	<FNC_WORK
.1:
	sta	<FSSQ_STAT+1

	lda	#$00
	sta	FSSQ_TCNT+1
	ldx	#5
	ldy	#1
_Fssq_Play:
	sta	FSSQ_LCNT,x
	sta	FSSQ_REG2,x
	sta	<FSSQ_NCNT,x
	sta	FSSQ_KEYON,x
	sta	FSSQ_EBASE,x
	dex
	dey
	bpl	_Fssq_Play
	rts

Fssq_TransArgSE:
	.db	$24	; bit <$b8
Fssq_TransArgBGM:
	clv
	sta	<FNC_WORK
	stx	<FNC_WORK+1

	; [N
	lda	#$ff
	ldx	#7
.1:
	sta	<FNC_ARG,x
	dex
	bpl	.1

	; `ltO擾
	ldy	#0
	lda	[FNC_WORK],y
	and	#$0f
	sta	<FNC_WORK+2

	; `ltOTRCHϊe[u
	; CHTRϊe[u[Nɐ
	inx		; same as ldx #0
;	ldy	#0
	beq	.4	; same as jmp
.2:
	sty	<FNC_ARG,x
	stx	<FNC_ARG+4,y
	inx
.3:
	iny
.4:
	lsr	a
	bcs	.2
	bne	.3
	stx	<FNC_WORK+3

	; e|l擾
	ldy	#1
	lda	[FNC_WORK],y

	bvs	.6
	sta	FSSQ_TEMPO

	; [NBGMp̈ɓ]
	ldx	#3
.5:
	lda	<FNC_ARG,x
	sta	FSSQ_CH,x
	lda	<FNC_ARG+4,x
	sta	FSSQ_TR,x
	dex
	bpl	.5
	bmi	.7	; same as jmp
.6:
	sta	FSSQ_TEMPO+1

	; [NSEp̈ɓ]
	lda	<FNC_ARG
	sta	FSSQ_CH+4
	lda	<FNC_ARG+1
	sta	FSSQ_CH+5
.7:

	; e[uƃGx[ve[u
	; AhX̓]
	iny	; same as ldy #2
	ldx	#0
	bvc	.8
	inx	; same as ldx #1
.8:
	lda	[FNC_WORK],y
	iny
	sta	FSSQ_LENTBL_L,x
	inx
	inx
	cpx	#8
	bcc	.8

	; V[PXf[^̃AhX̓]
	ldx	#0
	bvc	.9
	ldx	#4
.9:
	lda	[FNC_WORK],y
	iny
	sta	FSSQ_SEQ_L,x
	lda	[FNC_WORK],y
	iny
	sta	FSSQ_SEQ_H,x
	inx
	dec	<FNC_WORK+3
	bne	.9

	lda	<FNC_WORK+2
	rts

	; TEhhCo[ tF[hAEg
	; use reg: a
Fssq_Fadeout:
	lda	#$80
	sta	FSSQ_FADEOUT
	rts

	; TEhhCo[BGMtĊJ
	; use reg: a
Fssq_ResumeBGM:
	lda	FSSQ_PAUSE
	sta	<FSSQ_STAT
	ora	<FSSQ_STAT+1
	sta	<FSSQ_STAT+2
	rts

	; TEhhCo[BGMtꎞ~
	; use reg: a
Fssq_PauseBGM:
	lda	<FSSQ_STAT
	sta	FSSQ_PAUSE
;	jmp	Fssq_StopBGM

	; TEhhCo[BGMt~
	; use reg: a
Fssq_StopBGM:
	lda	#$00
	sta	<FSSQ_STAT
	lda	<FSSQ_STAT+1
	sta	<FSSQ_STAT+2
	rts

	; TEhhCo[SEt~
	; use reg: a x y
Fssq_StopSE:
	ldx	#0
.1:
	lsr	<FSSQ_STAT+1
	beq	.2

	ldy	FSSQ_TR,x
	bmi	.2
	lda	FSSQ_REG1,y
	sta	FSSQ_TREG,x
	lda	FSSQ_REG2,y
	sta	FSSQ_TREG+4,x
	lda	<FSSQ_REF
	ora	Bit,x
	ora	Bit+4,x
	sta	<FSSQ_REF
.2:
	inx
	cpx	#4
	bne	.1

	lda	<FSSQ_STAT
	sta	<FSSQ_STAT+2
	rts

	; TEhhCoXV
	; use reg: a x y
	; use work: 0-11
	; use arg: 0-3
Fssq_Update:
	; CfbNX̏
	ldx	#0
	stx	<_FSSQ_TR_INX
	stx	<_FSSQ_CCTRL
.main1:
	lda	<_FSSQ_CCTRL
	and	#$01
	tay

	lda	FSSQ_STAT,y
	bne	.main2
	ldx	Fssq_NextCh,y
	jmp	.main18

.main2:
	; oN؂ւ
	lda	<FSSQ_BCTRL
	cpy	#0
	bne	.main3
	asl	a
	asl	a
.main3:
	and	#$c0
	beq	.main5
	asl	a
	lda	FSSQ_BANK,y
	bcs	.main4
	.ifdef	FSSQ_CART_TYPE_MMC3
	jsr	SetPrgBankA
	beq	.main5	; same as jmp
	.endif
	.ifdef	FSSQ_CART_TYPE_MCAFE_E1
	sta	$a000
	bcc	.main5
	.endif
.main4:
	.ifdef	FSSQ_CART_TYPE_MMC3
	jsr	SetPrgBankB
	.endif
	.ifdef	FSSQ_CART_TYPE_MCAFE_E1
	sta	$b000
	.endif
.main5:

	lda	FSSQ_LENTBL_L,y
	sta	<_FSSQ_LENTBL
	lda	FSSQ_LENTBL_H,y
	sta	<_FSSQ_LENTBL+1
	lda	FSSQ_ENVTBL_L,y
	sta	<_FSSQ_ENVTBL
	lda	FSSQ_ENVTBL_H,y
	sta	<_FSSQ_ENVTBL+1

	; TickZo
	lda	FSSQ_TEMPO,y
	ldx	#$ff
	sec
.main6:
	inx
	sbc	#75
	bcs	.main6
;	clc
	adc	#75

	clc
	adc	FSSQ_TCNT,y
	sec
.main7:
	inx
	sbc	#75
	bcs	.main7
;	clc
	adc	#75
	sta	FSSQ_TCNT,y
	dex
	stx	<_FSSQ_TICK

.main10:
	; V[PX
	ldx	<_FSSQ_TR_INX
	ldy	FSSQ_CH,x
	bmi	.main17

	sty	<_FSSQ_CH_INX
	lda	Bit,y
	sta	<_FSSQ_CH_BIT
	and	FSSQ_STAT
	and	FSSQ_STAT+1
	cmp	#$01
	lda	<_FSSQ_CCTRL
	and	#$01
	bne	.main11
	ror	a
.main11:
	ora	Fssq_ToCtrl,y
	sta	<_FSSQ_CCTRL
	lda	FSSQ_TREG+12,y
	sta	<_FSSQ_PREG

	lda	<FSSQ_NCNT,x
	cmp	#$10
	bcs	.main16
	jsr	.sequence
.main16:
	jsr	.envelope

	ldx	<_FSSQ_TR_INX
	lda	<FSSQ_NCNT,x
	clc
	adc	<_FSSQ_TICK
	sta	<FSSQ_NCNT,x
.main17:
	; CfbNX̍XV
	inx
.main18:
	stx	<_FSSQ_TR_INX
	cpx	#FSSQ_BGM_TRACK_SIZE
	beq	.main20
	cpx	#FSSQ_TRACK_SIZE
	bne	.main10

	; tF[hAEgJE^XV
	ldy	FSSQ_FADEOUT
	beq	.main19
	lda	<SYS_CNT
	and	#$07
	bne	.main19
	lda	Int-$10,y
	sta	FSSQ_FADEOUT
	bne	.main19
	jmp	Fssq_StopBGM
.main19:
	rts
.main20:
	inc	<_FSSQ_CCTRL
	jmp	.main1

.lentbl:
	ldy	<_FSSQ_LENTBL+1
	lda	FSSQ_LBASE,x
	asl	a
	bcc	.len1
	iny
	clc
.len1:
	adc	<_FSSQ_LENTBL
	bcc	.len2
	iny
.len2:
	sta	<_FSSQ_WORK2
	sty	<_FSSQ_WORK2+1

	lda	<_FSSQ_WORK1
	and	#$f0
	lsr	a
	lsr	a
	lsr	a
	tay

	rts

	; /x/R}h̏(KeyOff)
.note_off:
	sta	<_FSSQ_WORK1
	lda	#$00
	sta	FSSQ_KEYON,x

	jsr	.lentbl
	iny
	lda	<FSSQ_NCNT,x
	sec
	sbc	[_FSSQ_WORK2],y
	sta	<FSSQ_NCNT,x

	lda	#$20
	bit	<_FSSQ_CCTRL
	bmi	.off4
	bne	.off3
	lda	FSSQ_VCNT,x
	beq	.off2

	; keyOff̃Gx[v̌lݒ
	ldy	FSSQ_EBASE,x
	lda	[_FSSQ_ENVTBL],y
	and	#$0f
	beq	.off2
	tay
	lda	Fssq_ReleaseRate,y
	sta	FSSQ_VACC,x
	jmp	.end0

	; ̏
.off2:
	lda	#$00
	sta	FSSQ_VCNT,x
.off3:
	lda	<_FSSQ_CH_BIT
	eor	#$ff
	and	<FSSQ_STAT+2
	sta	<FSSQ_STAT+2
.off4:
	jmp	.end0

.sequence:
	; V[PX|C^[N̈ɃRs[
	lda	FSSQ_SEQ_L,x
	sta	<_FSSQ_SEQ
	lda	FSSQ_SEQ_H,x
	sta	<_FSSQ_SEQ+1

	; /x/R}hKeyOff
	lda	FSSQ_KEYON,x
	bne	.note_off
	beq	.seq	; same as jmp

.seq_next1:
	iny
.seq_next:
	; V[PX|C^i߂
	tya
	clc
	adc	<_FSSQ_SEQ
	sta	<_FSSQ_SEQ
	bcc	.seq
	inc	<_FSSQ_SEQ+1
.seq:
	; V[PXR}hǂ
	ldy	#0
	lda	[_FSSQ_SEQ],y

	; /x/R}h̔
	cmp	#$20
	bcs	.note_on

	; R}h̕
	lsr	a
	tay
	lda	.jmptbl_l,y
	sta	<_FSSQ_WORK1
	lda	.jmptbl_h,y
	sta	<_FSSQ_WORK1+1
	ldy	#1
	jmp	[_FSSQ_WORK1]

	; /x/R}h̏(KeyOn)
.note_on:
	ldx	<_FSSQ_TR_INX
	sta	<_FSSQ_WORK1

	jsr	.lentbl
	lda	<FSSQ_NCNT,x
	sec
	sbc	[_FSSQ_WORK2],y
	sta	<FSSQ_NCNT,x
	iny
	lda	[_FSSQ_WORK2],y
	beq	.on1
	lda	<_FSSQ_WORK1
	sta	FSSQ_KEYON,x
.on1:
	lda	<_FSSQ_WORK1
	bit	<_FSSQ_CCTRL
	and	#$0f
	beq	.on_extend
	cmp	#$01
	bne	.on_note

	bit	<_FSSQ_CCTRL
	bmi	.on_extend
.on_rest:
	; x̏
	lda	<_FSSQ_CH_BIT
	eor	#$ff
	and	<FSSQ_STAT+2
	sta	<FSSQ_STAT+2

	lda	<_FSSQ_CCTRL
	and	#$20
	bne	.on_extend
	; `g,mCY
;	lda	#$00
	sta	FSSQ_VCNT,x
.on_extend:
	jmp	.end1

.on_note:
	; ̏
	clc
	adc	FSSQ_TBASE,x
	jsr	.key_on

	ldy	FSSQ_EBASE,x

	lda	<_FSSQ_CCTRL
	and	#$20
	bne	.note1

	; `g,mCY
	lda	[_FSSQ_ENVTBL],y
	iny
	sty	<FSSQ_EINX,x
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	tay
	lda	Fssq_SustainRate,y
	sta	FSSQ_VACC,x
	lda	#$ff
	sta	FSSQ_VCNT,x
	jmp	.end1
.note1:
	; Opg
	iny
	sty	<FSSQ_EINX,x
	jmp	.end1

.key_on:
	; L[I
	bit	<_FSSQ_CCTRL
	bvs	.keyon3

	; `g,Opg
	bmi	.keyon6

	.if	FSSQ_KEY_TABLE_SIZE = 0
	tay
	lda	Fssq_Apu_KeyTable_L-2,y
	sta	<FSSQ_KEY_L,x
	lda	Fssq_Apu_KeyTable_H-2,y
	.endif
	.if	FSSQ_KEY_TABLE_SIZE = 1
	tay
	lda	Fssq_Apu_KeyTable-2,y
	bpl	.keyon1
	asl	a
	sta	<FSSQ_KEY_L,x
	lda	Fssq_Apu_KeyTable-2+12,y
	lsr	a
	ror	<FSSQ_KEY_L,x
	bcc	.keyon2		; same as jmp
.keyon1:
	sta	<_FSSQ_WORK1
	lda	Fssq_Apu_KeyTable-2-12,y
	asl	a
	lsr	<_FSSQ_WORK1
	ror	a
	lsr	<_FSSQ_WORK1
	ror	a
	sta	<FSSQ_KEY_L,x
	lda	<_FSSQ_WORK1
.keyon2:
	.endif
	ora	#$08
	bne	.keyon9		; same as jmp

	; mCY
.keyon3:
	sec
	sbc	#$22
	bcs	.keyon4

	; mCYgw
	bit	<_FSSQ_CCTRL
	bmi	.keyon6
;	clc
	adc	#$10
	jmp	.keyon8
.keyon4:
	; Yw
;	sec
	adc	#1
	asl	a
	tay
	lda	[_FSSQ_LENTBL],y
	sta	<_FSSQ_WORK1
	iny
	lda	[_FSSQ_LENTBL],y
	sta	<_FSSQ_WORK1+1

	and	#$70
	beq	.keyon5
	tay
	lda	Xcn-16,y
	sta	FSSQ_PCMNUM
.keyon5:
	bit	<_FSSQ_CCTRL
	bmi	.keyon6
	lda	<_FSSQ_WORK1
	bne	.keyon7
	pla
	pla
	jmp	.on_rest
.keyon6:
	pla
	pla
	jmp	.end1
.keyon7:
	tay
	and	#$0f
	sta	FSSQ_EBASE,x

	lda	Xcn,y
	and	#$0f
	ora	#$30
	sta	FSSQ_REG1,x

	lda	<_FSSQ_WORK1+1
.keyon8:
	and	#$8f
	sta	<FSSQ_KEY_L,x
	lda	#$08
.keyon9:
	ldy	<_FSSQ_CH_INX
	sta	<FSSQ_KEY_H,x
	sta	FSSQ_TREG+12,y
	lda	<FSSQ_KEY_L,x
	sta	FSSQ_TREG+8,y
	lda	FSSQ_REG1,x
	sta	FSSQ_TREG,y

	lda	<FSSQ_REF+1
	ora	<_FSSQ_CH_BIT
	ora	Bit+4,y
	sta	<FSSQ_REF+1
	lda	<FSSQ_REF
	ora	<_FSSQ_CH_BIT
	sta	<FSSQ_REF

	lda	<FSSQ_STAT+2
	ora	<_FSSQ_CH_BIT
	sta	<FSSQ_STAT+2

	rts

.jmptbl_l:
	.db	LOW(.cmd_term),     LOW(.cmd_call)
	.db	LOW(.cmd_repeat2),  LOW(.cmd_repeat3)
	.db	LOW(.cmd_repeat4),  LOW(.cmd_repeat)
	.db	LOW(.cmd_rep_wide), LOW(.seq_next)
	.db	LOW(.cmd_reg1),     LOW(.cmd_tbase)
	.db	LOW(.cmd_ebase),    LOW(.cmd_percuss)
	.db	LOW(.cmd_volume1),  LOW(.cmd_volume2)
	.db	LOW(.seq_next),     LOW(.seq_next)
.jmptbl_h:
	.db	HIGH(.cmd_term),     HIGH(.cmd_call)
	.db	HIGH(.cmd_repeat2),  HIGH(.cmd_repeat3)
	.db	HIGH(.cmd_repeat4),  HIGH(.cmd_repeat)
	.db	HIGH(.cmd_rep_wide), HIGH(.seq_next)
	.db	HIGH(.cmd_reg1),     HIGH(.cmd_tbase)
	.db	HIGH(.cmd_ebase),    HIGH(.cmd_percuss)
	.db	HIGH(.cmd_volume1),  HIGH(.cmd_volume2)
	.db	HIGH(.seq_next),     HIGH(.seq_next)

	; ʕύXR}h
.cmd_volume2:
	lda	#2
	bne	.cmd_vol1
.cmd_volume1:
	lda	#1
.cmd_vol1:
	bcc	.cmd_vol2
	eor	#$ff
.cmd_vol2:
	adc	FSSQ_REG1,x
	clc
	bcc	.cmd_reg1_1	; same as jmp

	; WX^1ݒR}h
.cmd_reg1:
;	ldx	<_FSSQ_TR_INX

	lda	[_FSSQ_SEQ],y
	iny
.cmd_reg1_1:
	sty	<_FSSQ_WORK1
	ldy	<_FSSQ_CH_INX

	bcs	.cmd_reg2

	sta	FSSQ_REG1,x

	bit	<_FSSQ_CCTRL
	bmi	.cmd_reg2_2

	sta	FSSQ_TREG,y
	lda	<_FSSQ_CH_BIT
	bne	.cmd_reg2_1

	; WX^2ݒR}h
.cmd_reg2:
	sta	FSSQ_REG2,x

	bit	<_FSSQ_CCTRL
	bmi	.cmd_reg2_2

	sta	FSSQ_TREG+4,y
	lda	Bit+4,y
.cmd_reg2_1:
	ora	<FSSQ_REF
	sta	<FSSQ_REF
.cmd_reg2_2:
	ldy	<_FSSQ_WORK1
	jmp	.seq_next

	; x[XݒR}h
.cmd_tbase:
;	ldx	<_FSSQ_TR_INX

	lda	[_FSSQ_SEQ],y

	bcs	.cmd_lbase

	sta	FSSQ_TBASE,x
	jmp	.seq_next1

	; x[XݒR}h
.cmd_lbase:
	sta	FSSQ_LBASE,x
	jmp	.seq_next1

	; Gx[vx[XݒR}h
.cmd_ebase:
;	ldx	<_FSSQ_TR_INX

	lda	[_FSSQ_SEQ],y

	bcs	.cmd_tempo

	sta	FSSQ_EBASE,x
	jmp	.seq_next1

	; e|ݒR}h
.cmd_tempo:
;	ldy	#1
	cpx	#FSSQ_BGM_TRACK_SIZE
	bcs	.cmd_tempo1
	dey
.cmd_tempo1:
	sta	FSSQ_TEMPO,y

	ldy	#2
	jmp	.seq_next

	; ŉR}h
.cmd_percuss:
	bcs	.cmd_loop_cnt

	lda	[_FSSQ_SEQ],y
	sta	FSSQ_PCMNUM
	iny
	jmp	.seq_next

	; [vJE^R}h
.cmd_loop_cnt:
	inc	FSSQ_LOOP_CNT
	jmp	.seq_next

	; s[gR}h(-2,3)
	; s[gR}h(-2,4)
.cmd_repeat2:
	lda	#$3e
	bne	.cmd_rep1	; same as jmp

	; s[gR}h(-3,2)
	; s[gR}h(-3,3)
.cmd_repeat3:
	lda	#$1d
	bne	.cmd_rep1	; same as jmp

	; s[gR}h(-4,2)
	; s[gR}h(-4,3)
.cmd_repeat4:
	lda	#$1c
	bne	.cmd_rep1	; same as jmp

	; L惊s[gR}h
.cmd_rep_wide:
;	ldx	<_FSSQ_TR_INX
	lda	Int+(FSSQ_REG2-FSSQ_LCNT),x
	tax

	; s[gR}h
.cmd_repeat:
;	ldx	<_FSSQ_TR_INX

	lda	[_FSSQ_SEQ],y
	iny

	bcs	.cmd_rep5

	; V[g`
.cmd_rep1:
	sta	<_FSSQ_WORK1
	ora	#$e0
	sta	<_FSSQ_WORK1+1

	; [vJE^mF
	; 0:[v 0ȊO:[v
	lda	FSSQ_LCNT,x
	bne	.cmd_rep3

	; [v̏
	php
	lda	<_FSSQ_WORK1
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	plp
	adc	#2
.cmd_rep2:
	sta	FSSQ_LCNT,x

.cmd_rep3:
	dec	FSSQ_LCNT,x
	beq	.cmd_rep4

	; V[PX|C^ɔѐ܂ł̋Z
	lda	<_FSSQ_WORK1+1
	clc
	adc	<_FSSQ_SEQ
	sta	<_FSSQ_SEQ
	lda	<_FSSQ_SEQ+1
	adc	#$ff
	sta	<_FSSQ_SEQ+1
.cmd_rep4:
	ldx	<_FSSQ_TR_INX
	jmp	.seq_next

	; O`
.cmd_rep5:
	sta	<_FSSQ_WORK1
	lda	[_FSSQ_SEQ],y
	iny
	sta	<_FSSQ_WORK1+1

	; [vJE^mF
	; 0:[v 0ȊO:[v
	lda	FSSQ_LCNT,x
	bne	.cmd_rep3

	lda	<_FSSQ_WORK1
	bcs	.cmd_rep2	; same as jmp


	; Tu[`R}h
.cmd_call:
	bcs	.cmd_jmp

;	ldx	<_FSSQ_TR_INX

	lda	[_FSSQ_SEQ],y
	asl	a
	lda	<_FSSQ_SEQ
	adc	#0
	sta	FSSQ_S_SEQ_L,x
	lda	<_FSSQ_SEQ+1
	adc	#0
	sta	FSSQ_S_SEQ_H,x
	lda	FSSQ_TBASE,x
	sta	FSSQ_S_TBASE,x
	lda	FSSQ_LBASE,x
	sta	FSSQ_S_LBASE,x

	; WvR}h
.cmd_jmp:
	lda	[_FSSQ_SEQ],y

	asl	a
	bcs	.cmd_jmp2

	; V[g`
	cmp	#$80
	ror	a
	sta	<_FSSQ_WORK1
	ora	#$7f
	bmi	.cmd_jmp1
	lda	#$00
.cmd_jmp1:
	sta	<_FSSQ_WORK1+1
	bcc	.cmd_jmp3	; same as jmp

	; O`
.cmd_jmp2:
	sta	<_FSSQ_WORK1

	iny
	lda	[_FSSQ_SEQ],y
	cmp	#$80
	ror	a
	sta	<_FSSQ_WORK1+1
	ror	<_FSSQ_WORK1

.cmd_jmp3:
	; V[PX|C^ɔѐ܂ł̋Z
	lda	<_FSSQ_SEQ
	clc
	adc	<_FSSQ_WORK1
	sta	<_FSSQ_SEQ
	lda	<_FSSQ_SEQ+1
	adc	<_FSSQ_WORK1+1
	sta	<_FSSQ_SEQ+1
	jmp	.seq_next1

	; Tu[`A
.cmd_ret:
;	ldx	<_FSSQ_TR_INX

	lda	FSSQ_S_SEQ_H,x
	beq	.cmd_ret1

	sta	<_FSSQ_SEQ+1
	lda	FSSQ_S_SEQ_L,x
	sta	<_FSSQ_SEQ
	lda	FSSQ_S_TBASE,x
	sta	FSSQ_TBASE,x
	lda	FSSQ_S_LBASE,x
	sta	FSSQ_LBASE,x
	lda	#0
	sta	FSSQ_S_SEQ_H,x
	ldy	#2
.cmd_ret1:
	jmp	.seq_next

	; V[PX̏I[
.cmd_term:
	bcs	.cmd_ret

	lda	<_FSSQ_CH_BIT
	eor	#$ff
	sta	<_FSSQ_WORK1

	cpx	#FSSQ_BGM_TRACK_SIZE
	bcs	.cmd_term1

	; BGM
	and	<FSSQ_STAT
	sta	<FSSQ_STAT

	lda	<_FSSQ_WORK1
	ora	<FSSQ_STAT+1
	and	<FSSQ_STAT+2
	sta	<FSSQ_STAT+2
	jmp	.end0

	; SE
.cmd_term1:
	and	<FSSQ_STAT+1
	sta	<FSSQ_STAT+1

	lda	<_FSSQ_WORK1
	and	<FSSQ_STAT+2
	sta	<FSSQ_STAT+2

	ldy	<_FSSQ_CH_INX
	ldx	FSSQ_TR,y
	bmi	.end0

	lda	FSSQ_REG1,x
	sta	FSSQ_TREG,y
	lda	FSSQ_REG2,x
	sta	FSSQ_TREG+4,y
	cmp	#$80		; `g̃XC[vL

	lda	<FSSQ_REF
	ora	<_FSSQ_CH_BIT
	ora	Bit+4,y
	sta	<FSSQ_REF
	bcs	.end0

	lda	FSSQ_KEYON,x
	and	#$0f
	cmp	#2
	bcc	.end0

	clc
	adc	FSSQ_TBASE,x
	bit	<_FSSQ_CCTRL
	bvc	.cmd_term3
	cmp	#$22
	bcs	.end0	; mCỸYw͏O
.cmd_term3:
	jsr	.key_on
;	jmp	.end0

.end0:
	clc
	.db	$a9	; lda #$38
.end1:
	sec
	; V[PX|C^̏߂
	ldx	<_FSSQ_TR_INX
	lda	<_FSSQ_SEQ
	adc	#0
	sta	FSSQ_SEQ_L,x
	lda	<_FSSQ_SEQ+1
	adc	#0
	sta	FSSQ_SEQ_H,x
	rts

	; Gx[v
.envelope:
;	ldx	<_FSSQ_TR_INX

	ldy	<FSSQ_EINX,x
	lda	#$00
	sta	<_FSSQ_WORK1+1
	sta	<_FSSQ_WORK2+1
	beq	.env3	; same as jmp
.env1:
	cmp	#$ff
	bcc	.env2
	dey
	lda	#$40
	bne	.env4	; same as jmp
.env2:
;	clc
	adc	Int,y
	tay
.env3:
	lda	[_FSSQ_ENVTBL],y
	iny
	cmp	#$d0
	bcs	.env1

.env4:
	sta	<_FSSQ_WORK2
	and	#$f0
	sta	<_FSSQ_WORK1
	eor	<_FSSQ_WORK2
	sta	<_FSSQ_WORK2
	beq	.env7

	lsr	a
	lda	[_FSSQ_ENVTBL],y
	iny
	sta	<_FSSQ_WORK2+1
	and	#$f0
	sta	<_FSSQ_WORK1+1
	eor	<_FSSQ_WORK2+1
	bcs	.env5

	sta	<_FSSQ_WORK2+1
	lda	[_FSSQ_ENVTBL],y
	iny
	sta	<_FSSQ_WORK2
	jmp	.env7
.env5:
	cmp	#$08
	bcc	.env6
	ora	#$f0
.env6:
	sta	<_FSSQ_WORK2
	sbc	<_FSSQ_WORK2
	eor	#$ff
	sta	<_FSSQ_WORK2+1
.env7:
	tya
	sta	<FSSQ_EINX,x

	; 
	lda	#$20
	bit	<_FSSQ_CCTRL
	bmi	.env10
	bne	.env11

	; `g,mCY
	lda	FSSQ_VCNT,x
	beq	.env10
	sec
	sbc	FSSQ_VACC,x
	bcs	.env8
	lda	#$00
.env8:
	sta	FSSQ_VCNT,x
	bne	.env12

.env9:
	; ̏
	lda	<_FSSQ_CH_BIT
	eor	#$ff
	and	<FSSQ_STAT+2
	sta	<FSSQ_STAT+2
.env10:
	rts

.env11:
	; Opg
	lda	FSSQ_FADEOUT
	bne	.env9
	ldy	<_FSSQ_CH_INX
	jmp	.env16

.env12:
	; 
	lsr	a
	eor	FSSQ_REG1,x
	and	#$f0
	eor	FSSQ_REG1,x
	tay
	lda	Fssq_MulTable,y
	and	#$0f
	ora	<_FSSQ_WORK1
	clc
	adc	#$30
	tay
	bmi	.env13
	lda	Fssq_MulTable,y
	and	#$0f
	bpl	.env14		; same as jmp
.env13:
	lda	Fssq_MulTable-$80,y
	lsr	a
	lsr	a
	lsr	a
	lsr	a
.env14:
	ora	FSSQ_FADEOUT
	cmp	#$10
	bcc	.env15
	tay
	lda	Fssq_MulTable-16,y
	and	#$0f
.env15:
	sta	<_FSSQ_WORK1

	ldy	<_FSSQ_CH_INX
	lda	FSSQ_REG1,x
	and	#$f0
	ora	<_FSSQ_WORK1
	eor	<_FSSQ_WORK1+1
	sta	FSSQ_TREG,y
	lda	<FSSQ_REF
	ora	<_FSSQ_CH_BIT
	sta	<FSSQ_REF

.env16:
	; 
	lda	FSSQ_REG2,x
	bmi	.env18

	lda	<FSSQ_KEY_L,x
	clc
	adc	<_FSSQ_WORK2
	sta	FSSQ_TREG+8,y

	lda	<FSSQ_KEY_H,x
	adc	<_FSSQ_WORK2+1
	and	#$07
	ora	#$08
	cmp	<_FSSQ_PREG
	beq	.env19

	sta	FSSQ_TREG+12,y
	lda	<_FSSQ_CH_BIT
	ora	Bit+4,y
.env17:
	ora	<FSSQ_REF+1
	sta	<FSSQ_REF+1
.env18:
	rts

.env19:
	lda	<_FSSQ_CH_BIT
	bne	.env17	; same as jmp

Fssq_Reflect:
	; Đ`l̐ݒ(WX^ݒ)
	lda	$4015
	and	#$10
	ora	<FSSQ_STAT
	ora	<FSSQ_STAT+1
	sta	$4015

	; APUWX^ւ̔f
	ldx	#0
	beq	.3	; same as jmp
.1:
	ldy	Fssq_ToReflect,x
	lda	FSSQ_TREG,x
	sta	$4000,y
.2:
	inx
.3:
	lsr	<FSSQ_REF
	bcs	.1
	bne	.2

	ldx	#8
	bne	.6	; same as jmp
.4:
	ldy	Fssq_ToReflect,x
	lda	FSSQ_TREG,x
	sta	$4000,y
.5:
	inx
.6:
	lsr	<FSSQ_REF+1
	bcs	.4
	bne	.5

	; Đ`l̐ݒ(x)
	lda	$4015
	and	#$10
	ora	<FSSQ_STAT+2
	sta	$4015

	; PCMύX
	ldy	FSSQ_PCMNUM
	bmi	.7
	lda	#$ff
	sta	FSSQ_PCMNUM
	jmp	[FSSQ_PCMCALL]
.7:
	rts

